/**
 * File:    GefEmfEditingDomain.java
 * Created: 03.03.2006
 *
 *
 * Copyright (c) 2006  University of Augsburg <www.informatik.uni-augsburg.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 */


package de.uniAugsburg.agilPro.editors;


import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.gef.DefaultEditDomain;
import org.eclipse.ui.IEditorPart;




/**
 * A GEF editing domain that also contains a EMF editing domain.
 * 
 * @version $Id: GefEmfEditingDomain.java 71 2006-03-07 15:29:37Z bauermar $
 * @author Markus Bauer <markusbauer@users.sourceforge.net>
 */
public class GefEmfEditingDomain
    extends DefaultEditDomain
{
  /**
   * The editing domain for EMF.
   */
  private EditingDomain emfEditingDomain;




  /**
   * @param editorPart <code>null</code> or an IEditorPart.
   */
  public GefEmfEditingDomain(IEditorPart editorPart)
  {
    super(editorPart);
  }



  /**
   * @return Returns the emfEditingDomain.
   */
  public EditingDomain getEmfEditingDomain()
  {
    return emfEditingDomain;
  }



  /**
   * @param emfEditingDomain The emfEditingDomain to set.
   */
  public void setEmfEditingDomain(EditingDomain emfEditingDomain)
  {
    this.emfEditingDomain = emfEditingDomain;
  }

}
