/**
 * File:    EmfToGefCommandStackListenerAdapter.java
 * Created: 07.03.2006
 *
 *
 * Copyright (c) 2006  University of Augsburg <www.informatik.uni-augsburg.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 */


package de.uniAugsburg.agilPro.model.commands.gefEmfAdapter;


import java.util.EventObject;

import org.eclipse.gef.commands.CommandStackListener;





/**
 * Wraps an EMF
 * {@link org.eclipse.emf.common.command.CommandStackListener CommandStackListener}
 * to behave like a GEF {@link CommandStackListener}.
 * 
 * @version $Id: EmfToGefCommandStackListenerAdapter.java 72 2006-03-07 23:45:51Z bauermar $
 * @author Markus Bauer <markusbauer@users.sourceforge.net>
 */
public class EmfToGefCommandStackListenerAdapter
    implements CommandStackListener
{
  /**
   * The EMF CommandStackListener.
   */
  private org.eclipse.emf.common.command.CommandStackListener emfListener;




  /**
   * @param emfListener The EMF CommandStackListener.
   */
  public EmfToGefCommandStackListenerAdapter(
      org.eclipse.emf.common.command.CommandStackListener emfListener)
  {
    this.emfListener = emfListener;
  }



  /* (non-Javadoc)
   * @see org.eclipse.gef.commands.CommandStackListener#commandStackChanged(java.util.EventObject)
   */
  public void commandStackChanged(EventObject event)
  {
    emfListener.commandStackChanged(event);
  }



  /* (non-Javadoc)
   * @see java.lang.Object#equals(java.lang.Object)
   */
  @Override
  public boolean equals(Object obj)
  {
    if (obj != null && obj instanceof EmfToGefCommandStackListenerAdapter)
    {
      return emfListener
          .equals(((EmfToGefCommandStackListenerAdapter) obj).emfListener);
    }

    return false;
  }
}
